
public class Fraction {
	private int denom;
	private int numer;
	private boolean finite = true;
	public Fraction(int num,int den){
		if(den == 0){
			if(num == 0){
				den = 1;
				num = 1;
			}else{
				finite = false;
			}
		}else{
			if(num == 0){
				den = 1;
				num = 0;
			}
			if(den < 0){
				num = -num;
				den = -den;
			}
			for(int i = 2;i < (num + den) - (int)Math.abs(num - den);i++){
				if(den % i == 0 && num % i == 0){
					num /= i;
					den /= i;
					i = 2;
				}
			}
		}
		denom = den;
		numer = num;
	}
	public String toString(){
		if(!finite)return "infinite";
		if(numer == 0)return "" + 0;
		return "" + numer + "/" + denom;
	}
	public int getDenom(){
		return denom;
	}
	public int getNumer(){
		return numer;
	}
	public double getValue(){
		if(!finite)
			return 1000000;
		return(numer / denom);
	}
	public Fraction add(Fraction a){
		return new Fraction((a.getDenom()*numer+a.getNumer()*denom),a.getDenom()*denom);
	}
	public Fraction subtract(Fraction a){
		return new Fraction((a.getDenom()*numer-a.getNumer()*denom),a.getDenom()*denom);
	}
	public Fraction multiply(Fraction a){
		return new Fraction(numer*a.getNumer(),a.getDenom()*denom);
	}
	public Fraction divide(Fraction a){
		return new Fraction(numer*a.getDenom(),a.getNumer()*denom);
	}
}
