import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.imageio.ImageIO;

public class Text{
	ArrayList<Integer> Symbols = new ArrayList<Integer>();
	String record;
	public Text(String text){
		record = text;
		int set = 0;
		for(int i = 0; i < text.length(); i++){
			switch (text.charAt(i))
			{
			case '`':
				Symbols.add(0);
				switch (set)
				{
				case 0:
					set = 100;
					if(Symbols.get(i-1) % 100 == 51){
						Symbols.set(i-1,0);
						set = 300;
					}
	                break;
				case 100:
					set = 0;
					if(Symbols.get(i-1) % 100 == 51){
						Symbols.set(i-1,0);
						set = 400;
					}
					if(Symbols.get(i-1) % 100 == 15){
						Symbols.set(i-1,0);
						set = 200;
					}
	                break;
				case 200:
					set = 0;
					if(Symbols.get(i-1) % 100 == 51){
						Symbols.set(i-1,0);
						set = 500;
					}
	                break;
				case 300:
					set = 0;
	                break;
				case 400:
					set = 100;
	                break;
				case 500:
					set = 200;
	                break;
				}
                break;
			case '~':
				Symbols.add(0);
				if(set == 0)
					set = 800;
				else if(set == 800)
					set = 0;
				break;
			case '1':
				Symbols.add(1 + set);
                break;
			case '2':
				Symbols.add(2 + set);
                break;
			case '3':
				Symbols.add(3 + set);
                break;
			case '4':
				Symbols.add(4 + set);
                break;
			case '5':
				Symbols.add(5 + set);
                break;
			case '6':
				Symbols.add(6 + set);
                break;
			case '7':
				Symbols.add(7 + set);
                break;
			case '8':
				Symbols.add(8 + set);
                break;
			case '9':
				Symbols.add(9 + set);
                break;
			case '0':
				if(Symbols.get(i-1) % 100 >= 1 || Symbols.get(i-1) % 100 <= 10)
				Symbols.add(10 + set);
                break;
			case '+':
				Symbols.add(11 + set);
                break;
			case '-':
				Symbols.add(12 + set);
                break;
			case '=':
				Symbols.add(13 + set);
                break;
			case '*':
				Symbols.add(14 + set);
                break;
			case '/':
				Symbols.add(15 + set);
                break;
			case '(':
				Symbols.add(16 + set);
                break;
			case ')':
				Symbols.add(17 + set);
                break;
			case 'x':
				if(i > 0){
					if(Symbols.get(i-1) % 100 == 14)
						Symbols.set(i-1,0);
				}
				Symbols.add(21 + set);
                break;
			case 'y':
				Symbols.add(22 + set);
                break;
			case '^':
				Symbols.add(51 + set);
                break;
			case '?':
				Symbols.add(34 + set);
                break;
			};
		}
	}
	public void draw(Graphics2D g){
    	BufferedImage CharSheet = null;
		try {
			CharSheet = ImageIO.read(new File("Images/KBM_Symbols.png"));
		} catch (IOException e1) {
			e1.printStackTrace();
		}
        AffineTransform nl = new AffineTransform();
        AffineTransform gl = new AffineTransform();
        g.setTransform(nl);
		double kerning = 1;
		double store = 1;
		int setStore = 0;
		double fractionStart = 0;
		int fractionLength = 0;
		int fractionLength2 = 0;
		int fractionTotal = 0;
		for(int i = 0; i < Symbols.size(); i++){
			if(Symbols.get(i) % 100 != 0){
				BufferedImage CroppedCharSheet = CharSheet.getSubimage(43 * ((Symbols.get(i) - 1) % 10) + 1, 50 * ((Symbols.get(i) % 100) - ((Symbols.get(i) - 1) % 10) - 1) / 10, 40, 49);
				if(Symbols.get(i) < 100 && Symbols.get(i) != 34){
					kerning++;
					store = kerning;
					setStore = 0;
					gl = new AffineTransform();
					gl.translate((int) (30 * kerning), 65);
					gl.scale(0.8, 0.8);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) > 100 && Symbols.get(i) < 200){
					if(setStore == 0){
						fractionStart = kerning;
						for(int k = i; k < Symbols.size(); k++){
							if(fractionLength == 0){
								if(Symbols.get(k) > 200 && Symbols.get(k) < 300){
									fractionLength = k - i - 1;
								}
							}else{
								if(Symbols.get(k) < 100 && fractionLength2 == 0){
									fractionLength2 = k - i - fractionLength;
								}
							}
						}
						if(fractionLength > fractionLength2){
							fractionTotal = fractionLength;
						}else{
							fractionTotal = fractionLength2;
						}
						store = kerning;
					}
					setStore = 1;
					kerning++;
					gl = new AffineTransform();
					System.out.println(fractionLength);
					gl.translate(30 * (kerning - fractionStart + (fractionStart + (fractionTotal - fractionLength) / 2)), 50);
					gl.scale(0.6, 0.6);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) > 200 && Symbols.get(i) < 300){
					if(setStore == 1){
						g.drawLine((int) (30 * store + 30), 85, (int) (30 * (store + fractionTotal - 1) + 30), 85);
						g.drawLine((int) (30 * store + 30), 86, (int) (30 * (store + fractionTotal - 1) + 30), 86);
						kerning = store;
						setStore = 2;
					}
					kerning++;
					gl = new AffineTransform();
					gl.translate(30 * kerning, 90);
					gl.scale(0.6, 0.6);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) > 300 && Symbols.get(i) < 400){
					kerning += 0.5;
					gl = new AffineTransform();
					gl.translate(30 * (kerning + 0.5), 40);
					gl.scale(0.6, 0.6);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) > 800 && Symbols.get(i) < 900){
					kerning++;
					store = kerning;
					setStore = 0;
					g.drawLine((int)(30 * kerning), 60, (int) (30 * kerning) + 30, 60);
					g.drawLine((int)(30 * kerning), 61, (int) (30 * kerning) + 30, 61);
					gl = new AffineTransform();
					gl.translate((int)(30 * kerning), 65);
					gl.scale(0.8, 0.8);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) == 34){
					kerning++;
					store = kerning;
					setStore = 0;
					gl = new AffineTransform();
					gl.translate((int) (30 * kerning), 60);
					gl.scale(1, 1);
					g.setTransform(gl);
					g.drawImage(CroppedCharSheet, 0, 0, null);
					g.setTransform(nl);
				}
				if(Symbols.get(i) == 22){
					CroppedCharSheet = CharSheet.getSubimage(43 * ((Symbols.get(i) - 1) % 10) + 1, 50 * ((Symbols.get(i) % 100) - ((Symbols.get(i) - 1) % 10) - 1) / 10 + 50, 40, 49);
					if(Symbols.get(i) < 100){
						gl = new AffineTransform();
						gl.translate((int) (30 * kerning), 104);
						gl.scale(0.8, 0.8);
						g.setTransform(gl);
						g.drawImage(CroppedCharSheet, 0, 0, null);
						g.setTransform(nl);
					}
					if(Symbols.get(i) > 100 && Symbols.get(i) < 200){
						g.drawImage(CroppedCharSheet, (int) (40 * kerning), 85, null);
					}
					if(Symbols.get(i) > 200 && Symbols.get(i) < 300){
						g.drawImage(CroppedCharSheet, (int) (40 * kerning), 125, null);
					}
				}
			}
		}
	}
}
